Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 750527 - dev-qt/qt-creator-4.14.0 version bump
Summary: dev-qt/qt-creator-4.14.0 version bump
Status: CONFIRMED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal with 6 votes (vote)
Assignee: Davide Pesavento
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2020-10-21 08:13 UTC by Sergey Torokhov
Modified: 2021-02-25 15:01 UTC (History)
9 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
Patch adding new ebuild and patch file for Qt Creator 4.13.2 (qt-creator-4.13.2.patch,18.83 KB, patch)
2020-11-20 08:15 UTC, Hans F. Nordhaug
Details | Diff
Patch adding new ebuild and patch file for Qt Creator 4.13.3 (qt-creator-4.13.3.patch,18.84 KB, patch)
2020-11-23 10:45 UTC, Hans F. Nordhaug
Details | Diff
Patch adding new ebuild and patch file for Qt Creator 4.13.3 and 4.14.o (qt-creator-4.14.0.patch,30.91 KB, patch)
2020-12-24 13:10 UTC, Hans F. Nordhaug
Details | Diff
simplified qt-creator-4.14.0.ebuild (qt-creator-4.14.0.ebuild,6.85 KB, text/plain)
2021-01-28 00:39 UTC, Victor Mataré
Details
Improved patch adding new ebuild and patch file for Qt Creator 4.13.3 and 4.14.0 (qt-creator-4.14.0-r1.patch,31.21 KB, patch)
2021-02-23 12:02 UTC, Hans F. Nordhaug
Details | Diff
Patch adding new ebuilds for Qt Creator 4.13.3 and 4.14.1 (qt-creator-4.14.1.patch,32.63 KB, patch)
2021-02-25 15:01 UTC, Hans F. Nordhaug
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Sergey Torokhov 2020-10-21 08:13:57 UTC
Current qt-creator-4.12.3.ebuild of portage tree is compatible only with llvm:9 and :10, but not with llvm:10.1 or :11.

Please bump version to 4.13.2 and fix there compatibility with newer llvm slots where it possible.

Reproducible: Always
Comment 1 Hans F. Nordhaug 2020-11-20 08:15:20 UTC
Created attachment 673363 [details, diff]
Patch adding new ebuild and patch file for Qt Creator 4.13.2

This patchs also adds support for llvm / clang 11.0.0.
Comment 2 Hans F. Nordhaug 2020-11-20 08:16:21 UTC
NB! If you are using Clang 11, you will also want / need patch from the following issue until it's resolved: https://bugs.gentoo.org/755668
Comment 3 Cyril 2020-11-20 09:18:39 UTC
Nice,

Works after removing lines 111-112 in patch 
+-- 
+2.26.2

Thanks Hans
Comment 4 Hans F. Nordhaug 2020-11-23 10:45:58 UTC
Created attachment 674449 [details, diff]
Patch adding new ebuild and patch file for Qt Creator 4.13.3

Qt Creator 4.13.3 just released. Patch updated - without the stupid mistake.
Comment 5 Hans F. Nordhaug 2020-12-11 15:25:37 UTC
From /usr/portage/profiles/package.mask:

# Michał Górny <mgorny@gentoo.org> (2020-11-29)
# An awful hack-package that was dumped on others, and not touched
# by the person adding it since.  Depends on obsolete LLVM versions
# and needs a version bump.
# Removal in 30 days.  Bug #734732.
dev-libs/libclangformat-ide

Removing that package causes problems for Clang support in Qt Creator and is a serious issue. Please visit https://bugs.gentoo.org/734732 and raise your concerns.
Comment 6 Dmitry Grigoriev 2020-12-22 01:36:11 UTC
(In reply to Hans F. Nordhaug from comment #4)
> Qt Creator 4.13.3 just released. Patch updated - without the stupid mistake.

Thank you, works like a charm! (together with patch from #755668)
Comment 7 Hans F. Nordhaug 2020-12-24 13:10:41 UTC
Created attachment 679374 [details, diff]
Patch adding new ebuild and patch file for Qt Creator 4.13.3 and 4.14.o

Updated patch adding support for the new released Qt Creator 4.14.0. 

NB! Qt Creator 4.14.0 doesn't need the dylib fix anymore, but the ClangFormat patch is still needed and hence the dev-libs/libclangformat-ide package.
Comment 8 Hans F. Nordhaug 2020-12-24 13:14:44 UTC
NB! Because of the erroneous profile use mask of clang (in /usr/portage/profiles/base/package.use.mask), you should add a file  /etc/portage/profile/package.use.mask containing "dev-qt/qt-creator -clang" to get any Clang feature, not only the Clang format plugin.
Comment 9 Simon Maurer 2021-01-13 10:04:17 UTC
Thanks for the ebuild. But after the update, the clang code model could't find some of the standard header files (e.g. stdbool.h and stddef.h). I had to add the line
sed -i -e "/^CLANG_INCLUDE_DIR\s*=/s:\$\${LLVM_LIBDIR}:${EPREFIX}/usr/lib:" src/shared/clang/clang_defines.pri || die
to src_prepare(). Looks like CLANG_RESOURCE_DIR was renamed to CLANG_INCLUDE_DIR in clang_defines.pri
Comment 10 Victor Mataré 2021-01-28 00:39:30 UTC
Created attachment 684936 [details]
simplified qt-creator-4.14.0.ebuild

Here is an ebuild with the dependency on libclangformat-ide removed. libclangformat-ide is not essential, the clang code model works fine without it. Given the fact that libclangformat-ide is currently in limbo for lack of a maintainer, this should simplify acceptance. The ebuild also incorporates the CLANG_INCLUDE_DIR fix mentioned above by Simon Maurer.
Comment 11 Vyacheslav 2021-01-29 22:57:12 UTC
Victor Mataré tnx for your ebuild with working clang code model!
Comment 12 Hans F. Nordhaug 2021-02-23 12:02:25 UTC
Created attachment 688140 [details, diff]
Improved patch adding new ebuild and patch file for Qt Creator 4.13.3 and 4.14.0

- Instead of removing support for libclangformat-ide, added separate clangformat use flag so people without libclangformat-ide can get clang code model support in Qt Creator. This should make everybody happy.
- Contains CLANG_INCLUDE_DIR fix - thanks for spotting it.
- Removed client use flag for gdb as it no longer exists. Block gdb upgrade.
Comment 13 Sergey Torokhov 2021-02-23 14:11:38 UTC
Some new ebuilds of sys-devel/gdb has no USE flag "client".
Comment 14 Hans F. Nordhaug 2021-02-23 14:20:51 UTC
There are currently no sys-devel/gdb ebuilds that has the client use flag, and hence the client use flag in Qt Creator blockED the upgrade of gdb.
Comment 15 Sergey Torokhov 2021-02-23 21:07:20 UTC
Yes, "client" option now is always on in sys-devel/gdb and if gdb is already updated to current portage tree then attached qt-creator ebuild couldn't be merged with explicit requirements of sys-devel/gdb[client], e.g. for new qt-creator installation.
Comment 16 Sergey Torokhov 2021-02-23 21:10:31 UTC
(In reply to Hans F. Nordhaug from comment #14)
> There are currently no sys-devel/gdb ebuilds that has the client use flag,
> and hence the client use flag in Qt Creator blockED the upgrade of gdb.

Sorry, I checked ebuild instead of atrached patch that fix it.
Comment 17 Hans F. Nordhaug 2021-02-25 15:01:27 UTC
Created attachment 688356 [details, diff]
Patch adding new ebuilds for Qt Creator 4.13.3 and 4.14.1

Prior patch updated for newly released Qt Creator 4.14.1 and improved further. Separate clangformat use flag should work properly now. I had forgotten about "llvm_check_deps". Also updated clang plugin use flag descriptions in metadata.xml. (I didn't add clangformat use flag and son to version 4.13.3. Now that 4.14.1 is released, we probably should just skip it.)

I have also verified that my 11.0.0 patch for the (removed) dev-libs/libclangformat-ide package still works for 11.0.1. Will attach it under bug 755668 even it it is closed. I'm willing to maintain that package. (Will make a formal request somewhere.)

So, what more can I do to get a new version of Qt Creator into Gentoo?

NB! I just discovered bug 757756 that is almost a duplicate. These two bugs should reference each other.